
/*
  Prijem dat po RS485 ze Solar Inverteru
  kompilace Arduino 1.6.7
  20.8.2016
  Tomas Nevrela; tnweb.tode.cz
*/
#include <SoftEasyTransfer.h>
#include <SoftwareSerial.h>
SoftwareSerial mySerial(2, 4);//Arduino RX - RS485 RO, Arduino TX - RS485 DI
#define TXenableRS485 3 //RE + DE
#define LEDpin 13 // activity LED
int napeti, proud, vykon, teplota;
unsigned long vyroba;
// struktura pro komunikaci
struct PayloadTX {
  byte nodeID, address, command, func;
  int data1, data2, data3, data4, data5, data6, data7, data8;
  long data9, data10, data11, data12;
};
PayloadTX emon;
SoftEasyTransfer ET;

//=============================Setup===========================================
void setup() {
  pinMode(TXenableRS485, OUTPUT);
  Serial.begin(9600);
  mySerial.begin(9600); //ser. port pro RS485
  ET.begin(details(emon), &mySerial);
  digitalWrite(TXenableRS485, LOW);
  pinMode(LEDpin, OUTPUT);
}
//============================Hlavni smycka=====================================
void loop()
{
  prijem();
}
//=========================Prijem dat===========================================
//zpracovani prijatych dat a zobrazeni na serial monitoru
void prijem()
{
  if (ET.receiveData())
  {
    if (emon.nodeID == 12 )//Solar Inverter
    {
      napeti = emon.data1;//napeti ve Voltech
      proud = emon.data2;// proud ve formatu 865 (8,65A)
      vykon = emon.data3;// vykon ve Wattech
      teplota = emon.data4;// teplota ve °C
      vyroba = emon.data9;// vyroba ve Wh
      digitalWrite(LEDpin, HIGH); //status LED
      delay(40);
      digitalWrite(LEDpin, LOW);
      Serial.print("Napeti:");
      Serial.print(napeti);
      Serial.print("V ");
      Serial.print("Proud:");
      Serial.print(proud / 100);
      Serial.print(".");
      Serial.print((proud % 100) / 10);
      Serial.print("A ");
      Serial.print("Vykon:");
      Serial.print(vykon);
      Serial.print("W ");
      Serial.print("Teplota:");
      Serial.print(teplota);
      Serial.print("'C ");
      Serial.print("Vyroba:");
      Serial.print(vyroba);
      Serial.println("Wh");
    }
  }
}


